#include <string>
#include <vector>

typedef void KikiActionObject;
class KikiEvent;


class KikiAction
{
    public:

    enum { ONCE };

    KikiAction ( void * object,
                 int id,
                 const std::string & name,
                 int _duration,
                 int _mode );
    KikiAction ( void * object,
                 int id,
                 int _mode );
    virtual ~KikiAction ();

    void performWithEvent ( KikiEvent & event );

    protected:

    int action_id;
    std::string action_name;
    KikiActionObject * action_object;

    unsigned int start;
    int rest;
    int current;
    int last;
    int duration;
    int mode;
    KikiEvent * event;
};


class KikiEvent
{
    public:
    ~KikiEvent ();

    std::string event_name;
    std::vector<void*> actions;
};


KikiEvent::~KikiEvent ()
{
    while (actions.empty() == false)
    {
        actions.pop_back();
    }
}
